<?php

if (!defined('PARENT')) {
  exit;
}

//---------------------------------------------------
// Load language files..
//---------------------------------------------------

include(REL_PATH . 'content/language/global.php');
include(REL_PATH . 'content/language/js.php');
include(REL_PATH . 'content/language/admin.php');

//---------------------------------------------------
// Load include files..
//---------------------------------------------------

include(REL_PATH . 'control/timezones.php');
include(REL_PATH . 'control/functions.php');
include(PATH . 'control/currencies.php');

//---------------------------------------------------
// Database connection..
//---------------------------------------------------

include(REL_PATH . 'control/connect.php');
include(REL_PATH . 'control/classes/class.db.php');
$DB = new db();
$DB->db_conn();

//---------------------------------------------------
// Load global constants..
//---------------------------------------------------

include(REL_PATH . 'control/constants.php');

//---------------------------------------------------
// Load class files..
//---------------------------------------------------

mswfileController();
include(REL_PATH . 'control/system/core/sys-controller.php');
include(REL_PATH . 'control/classes/class.datetime.php');
include(REL_PATH . 'control/classes/class.page.php');
include(REL_PATH . 'control/classes/class.json.php');
include(PATH . 'control/classes/class.settings.php');
include(PATH . 'control/classes/class.payment.php');
include(PATH . 'control/classes/class.packages.php');
include(PATH . 'control/classes/class.members.php');
include(REL_PATH . 'control/classes/class.ht.php');

//---------------------------------------------------
// Declare and initialise..
//---------------------------------------------------

$JSON = new jsonHandler();
$SYS  = new mlSettings();
$PAY  = new mlPayment();
$PKG  = new mlPackages();
$MEM  = new mlMembers();
$HTA  = new htAccessControl();
$DT   = new mlDateTime();

//---------------------------------------------------
// Load settings..
//---------------------------------------------------

$Q = $DB->db_query("SELECT * FROM `" . DB_PREFIX . "settings`");

if ($Q == 'err') {
  header("Location: ../install/index.php");
  exit;
}

$SETTINGS       = $DB->db_object($Q);
$HTA->settings  = $SETTINGS;
$DT->settings   = $SETTINGS;
$SYS->settings  = $SETTINGS;
$PAY->settings  = $SETTINGS;
$PKG->settings  = $SETTINGS;
$MEM->settings  = $SETTINGS;
$SYS->datetime  = $DT;
$PAY->datetime  = $DT;
$PKG->datetime  = $DT;
$MEM->datetime  = $DT;
$MEM->hta       = $HTA;
$SYS->hta       = $HTA;

//---------------------------------------------------
// Check login
//---------------------------------------------------

if (isset($_GET['ajax']) && $_GET['ajax'] == 'login') {
  $loginBypass = true;
}

if (!isset($_SESSION['lbox_access_' . mswEncrypt(SECRET_KEY)]) && !isset($loginBypass)) {
  include(PATH . 'control/system/login.php');
}

//---------------------------------------------------
// Set timezone / timestamp
//---------------------------------------------------

$DT->setTimeZone($SETTINGS->timezone, $timezones);

//---------------------------------------------------
// Default vars..
//---------------------------------------------------

$cmd     = (isset($_GET['p']) ? $_GET['p'] : 'home');
$page    = (isset($_GET['next']) ? (int) $_GET['next'] : '1');
$limit   = $page * PER_PAGE - (PER_PAGE);
$eString = array();

//---------------------------------------------------
// Overrides
//---------------------------------------------------

if (isset($_GET['gateway'])) {
  $cmd = 'gateway';
}
if (isset($_GET['ajax'])) {
  $cmd = 'ajax';
}

//---------------------------------------------------
// Auto expire members
// Only run when accessing admin homepage
//---------------------------------------------------

if ($cmd == 'home') {
  mswAdminAutoExpire($DT, $DB, $eventlog, $SETTINGS);
}

?>