<?php

class processor extends db {

  public $settings;
  public $datetime;
  public $gateway;
  public $payoptions;

  public function enableSignup() {
    db::db_query("UPDATE `" . DB_PREFIX . "settings` SET
    `signup`      = 'yes',
    `signenable`  = '0000-00-00'
    ");
  }

  public function logMasterUserEvent($data = array()) {
    if ($data['log'] == 'yes') {
      if (is_dir(PATH . LOG_FOLDER) && is_writeable(PATH . LOG_FOLDER)) {
        $f  = (LOG_FILE_MASTER ? LOG_FILE_MASTER : 'master_login_events.txt');
        $s  = date('d-m-Y @ H:i:s') . ' - ' . $data['text'] . mswDefineNewline();
        file_put_contents(PATH . LOG_FOLDER . '/' . $f, $s, FILE_APPEND);
      }
    }
  }

  public function debugHandler($data = array()) {
    if (GW_DEBUG_MODE) {
      if (is_dir(PATH . LOG_FOLDER) && is_writeable(PATH . LOG_FOLDER)) {
        $s  = date('d-m-Y @ H:i:s') . ' - ' . $data['text'] . mswDefineNewline();
        if ($data['finish'] == 'yes') {
          $s .= '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -' . mswDefineNewline();
        }
        file_put_contents(PATH . LOG_FOLDER . '/_debug_' . $data['gateway'] . '.txt', $s, FILE_APPEND);
      }
    }
  }

  public function updateMemberPassword($data = array()) {
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `password`  = '" . mswSafeString($data['pass'], $this) . "',
    `resetcode` = ''
    WHERE `id`  = '{$data['id']}'
    ");
  }

  public function resetCode($mem) {
    $p = substr(sha1($mem->email . $mem->id . md5(time() . $mem->username)), 0, GEN_CODE_LENGTH);
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `resetcode` = '{$p}'
    WHERE `id`  = '{$mem->id}'
    ");
    return $p;
  }

  public function startFixedTimer($data = array()) {
    $now = $this->datetime->utcTime();
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `fixedtimer`  = '{$now}',
    `fixedexpiry` = '" . processor::fixedExpireDate($data['package']) . "'
    WHERE `id`    = '{$data['id']}'
    ");
    return $now;
  }

  public function updateMemberIP($id) {
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `ip`       = '" . mswGetRealIPAddr() . "'
    WHERE `id` = '{$id}'
    ");
  }

  public function updatePosition($id) {
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `position`  = ''
    WHERE `id`  = '{$id}'
    ");
  }

  public function timestamp($diff) {
    $years   = $diff / (365 * 60 * 60 * 24);
    $months  = ($diff - floor($years) * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24);
    $days    = ($diff - floor($years) * 365 * 60 * 60 * 24 - floor($months) * 30 * 60 * 60 * 24) / (60 * 60 * 24);
    $hours   = ($diff - floor($years) * 365 * 60 * 60 * 24 - floor($months) * 30 * 60 * 60 * 24 - floor($days) * 60 * 60 * 24) / (60 * 60);
    $mins    = ($diff - floor($years) * 365 * 60 * 60 * 24 - floor($months) * 30 * 60 * 60 * 24 - floor($days) * 60 * 60 * 24 - floor($hours) * 60 * 60) / 60;
    $seconds = ($diff - floor($years) * 365 * 60 * 60 * 24 - floor($months) * 30 * 60 * 60 * 24 - floor($days) * 60 * 60 * 24 - floor($hours) * 60 * 60 - floor($mins) * 60);
    // Return array of times..
    return array(
      'years' => $years,
      'months' => $months,
      'days' => $days,
      'hours' => $hours,
      'mins' => $mins
    );
  }

  // Not used!
  public function fixedAccessExpiry($data = array()) {
    $timer  = 'ok';
    $now    = $this->datetime->utcTime();
    $diff   = $now - $data['member']['fixedtimer'];
    $stamp  = processor::timestamp($diff);
    $years  = number_format($stamp['years'], 1);
    $months = number_format($stamp['months'], 1);
    $days   = number_format($stamp['days'], 1);
    $hours  = number_format($stamp['hours'], 1);
    $mins   = number_format($stamp['mins'], 1);
    if ($data['package']['fixed'] > 0) {
      switch ($data['package']['fixedtype']) {
        case 'mins':
          if ($mins > $data['package']['fixed']) {
            $timer = 'expired';
          }
          break;
        case 'hours':
          if ($hours > $data['package']['fixed']) {
            $timer = 'expired';
          }
          break;
        case 'days':
          if ($days > $data['package']['fixed']) {
            $timer = 'expired';
          }
          break;
        case 'months':
          if ($months > $data['package']['fixed']) {
            $timer = 'expired';
          }
          break;
        case 'years':
          if ($years > $data['package']['fixed']) {
            $timer = 'expired';
          }
          break;
      }
    }
    return $timer;
  }

  public function enableBox($id) {
    db::db_query("UPDATE `" . DB_PREFIX . "boxes` SET
    `status`     = 'yes',
    `autoenable` = '0000-00-00'
    WHERE `id`   = '{$id}'
    ");
  }

  public function signup($data = array()) {
    $code    = substr(sha1($data['form']['email'] . $data['form']['package'] . md5(time() . $data['form']['user'])), 0, GEN_CODE_LENGTH);
    $pkg     = processor::package(array(
      'id' => $data['form']['package']
    ));
    $custom  = array();
    // Custom fields..
    foreach ($_POST AS $k => $v) {
      $html = array();
      if (substr(strtolower($k), 0, 7) == 'custom_') {
        if (is_array($v)) {
          if (!empty($v)) {
            $html[] = ucfirst(strtoupper(substr($k, 7))) . ': ' . implode(', ', trim($v));
          }
        } else {
          if ($k != '') {
            $html[] = ucfirst(strtoupper(substr($k, 7))) . ': ' . trim($v);
          }
        }
        if (!empty($html)) {
          $custom[] = implode(mswDefineNewline(), $html);
        }
      }
    }
    db::db_query("INSERT INTO `" . DB_PREFIX . "members` (
    `name`,
    `email`,
    `username`,
    `password`,
    `package`,
    `lockbox`,
    `joined`,
    `ip`,
    `notes`,
    `status`,
    `gencode`,
    `eventlog`,
    `position`
    ) VALUES (
    '" . mswSafeString($data['form']['name'], $this) . "',
    '" . mswSafeString($data['form']['email'], $this) . "',
    '" . mswSafeString($data['form']['user'], $this) . "',
    '{$data['pass']}',
    '{$data['form']['package']}',
    '{$pkg->lockbox}',
    '" . date('Y-m-d') . "',
    '" . mswGetRealIPAddr() . "',
    '" . (!empty($custom) ? mswSafeString(implode(mswDefineNewline(), $custom), $this) : '') . "',
    'pay',
    '{$code}',
    '{$pkg->eventlog}',
    'start'
    )");
    return array(
      $code,
      db::db_last_insert_id()
    );
  }

  public function status($data = array()) {
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `status`   = '" . mswSafeString($data['status'], $this) . "'
    WHERE `id` = '{$data['id']}'
    ");
  }

  public function boxPayment($data = array()) {
    $now = $this->datetime->utcTime();
    if ($data['refund'] == 'yes') {
      $data['gateway']['amount'] = '-' . $data['gateway']['amount'];
    }
    db::db_query("INSERT INTO `" . DB_PREFIX . "payments` (
    `member`,
    `gateway`,
    `payment`,
    `ts`
    ) VALUES (
    '{$data['order']['id']}',
    '" . mswSafeString($this->gateway, $this) . "',
    '" . mswSafeString($data['gateway']['amount'], $this) . "',
    '{$now}'
    )");
  }

  public function activateFree($data = array()) {
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `name`          = '" . mswSafeString($data['form']['user'], $this) . "',
    `gateway`       = 'free',
    `joined`        = '" . date('Y-m-d') . "',
    `status`        = '{$data['status']}',
    `nextrenewdate` = '0000-00-00',
    `position`      = ''
    WHERE `id`      = '{$data['id']}'
    ");
    return db::db_aff_rows();
  }

  public function activate($data = array()) {
    $now = $this->datetime->utcTime();
    $nrd = $this->nextRenewalDate(array(
      'package' => $data['package'],
      'order' => $data['order']['id'],
      'formatted' => 'no',
      'return' => 'yes',
      'lang' => $data['lang']
    ));
    $nts = (!empty($data['gateway']['address']) ? mswDefineNewline() . mswDefineNewline() . mswSafeString(implode(mswDefineNewline(), $data['gateway']['address']), $this) : '');
    db::db_query("UPDATE `" . DB_PREFIX . "members` SET
    `name`          = '" . mswSafeString($data['gateway']['name'], $this) . "',
    `gateway`       = '" . mswSafeString($this->gateway, $this) . "',
    `joined`        = '" . date('Y-m-d') . "',
    `notes`         = IF(`notes`, CONCAT(`notes`, '{$nts}'), `notes`),
    `status`        = '" . mswSafeString($data['action'], $this) . "',
    `nextrenewdate` = '{$nrd}'
    WHERE `id`      = '{$data['order']['id']}'
    ");
    $rows = db::db_aff_rows();
    if ($rows > 0) {
      db::db_query("INSERT INTO `" . DB_PREFIX . "payments` (
      `member`,
      `gateway`,
      `payment`,
      `ts`
      ) VALUES (
      '{$data['order']['id']}',
      '" . mswSafeString($this->gateway, $this) . "',
      '" . mswSafeString($data['gateway']['amount'], $this) . "',
      '{$now}'
      )");
    }
    return $rows;
  }

  public function emailNotify($not) {
    return ($not ? unserialize($not) : array());
  }

  public function mailSubj($slot) {
    global $maillang;
    return str_replace(array(
      '{website}',
      '{gateway}'
    ), array(
      mswCleanData($this->settings->website),
      ucfirst($this->gateway)
    ), $maillang[$slot]);
  }

  public function logMsg($data = array()) {
    $gw = ($this->gateway == '2co' ? $data['lang'][1] : $this->gateway);
    if (in_array($data['slot'], array(
      '22'
    ))) {
      return str_replace(array(
        '{gateway}',
        '{status}'
      ), array(
        ucfirst($gw),
        ($data['status'] ? processor::cstatus($data['status']) : '')
      ), $data['loglang'][$data['slot']]);
    } else {
      return str_replace(array(
        '{gateway}'
      ), array(
        ucfirst($gw)
      ), $data['loglang'][$data['slot']]);
    }
  }

  public function order($data = array()) {
    if ($data['code']) {
      $QB = db::db_query("SELECT * FROM `" . DB_PREFIX . "members`
            WHERE `id`    = '{$data['id']}'
            AND `gencode` = '" . mswSafeString($data['code'], $this) . "'
            ");
    } else {
      $QB = db::db_query("SELECT * FROM `" . DB_PREFIX . "members`
            WHERE `id` = '{$data['id']}'
            ");
    }
    $ORD = db::db_object($QB);
    return (isset($ORD->id) ? $ORD : 'ERR');
  }

  public function refresh($data = array()) {
    $Q = db::db_query("SELECT `id` FROM `" . DB_PREFIX . "members`
         WHERE `gencode`   = '" . mswSafeString($data['code'], $this) . "'
         AND `id`          = '{$data['id']}'
         AND `status` NOT IN('pay','apay')
         ");
    $MEM   = db::db_object($Q);
    if (isset($MEM->id)) {
      return 'OK';
    } else {
      if ($data['count'] >= META_REFRESH_CHECK) {
        return 'FAIL';
      } else {
        return '<meta http-equiv="refresh" content="' . META_REFRESH_TIME . ';url=' . $this->settings->httppath . LOADFILE . '?return=' . $data['ret'] . '&amp;count=' . $data['count'] . '">';
      }
    }
  }

  public function currFormat($amount) {
    return number_format($amount, 2, '.', '');
  }

  public function cstatus($id) {
    $QB  = db::db_query("SELECT * FROM `" . DB_PREFIX . "statuses` WHERE `id` = '{$id}'");
    $STS = db::db_object($QB);
    return (isset($STS->status) ? $STS->status : '');
  }

  public function member($data = array()) {
    if ($data['auth']) {
      $QB  = db::db_query("SELECT * FROM `" . DB_PREFIX . "members`
             WHERE `username` = '" . mswSafeString($data['auth'], $this) . "'
             ");
      $MEM = db::db_object($QB);
    } else {
      $QB  = db::db_query("SELECT * FROM `" . DB_PREFIX . "members`
             WHERE `gencode` = '" . mswSafeString($data['loader'], $this) . "'
             AND `id`        = '{$data['id']}'
             ");
      $MEM = db::db_object($QB);
    }
    return (isset($MEM->id) ? $MEM : '');
  }

  public function box($box) {
    $QB  = db::db_query("SELECT * FROM `" . DB_PREFIX . "boxes` WHERE `id` = '" . mswSafeString($box, $this) . "'");
    $BOX = db::db_object($QB);
    return (isset($BOX->id) ? $BOX : '');
  }

  public function fixedExpireDate($p) {
    if ($p['fixedtype'] != 'none' && $p['fixed'] > 0) {
      return strtotime(date('Y-m-d H:i:s', strtotime('+' . $p['fixed'] . ' ' . $p['fixedtype'])));
    }
    return '0';
  }

  public function terms($data = array()) {
    switch ($data['package']['type']) {
      case 'fixed':
        if ($data['package']['fixedtype'] != 'none') {
          switch ($data['package']['fixedtype']) {
            case 'mins':
              $t = $data['lang'][25];
              break;
            case 'hours':
              $t = $data['lang'][26];
              break;
            case 'days':
              $t = $data['lang'][12];
              break;
            case 'months':
              $t = $data['lang'][13];
              break;
            case 'years':
              $t = $data['lang'][14];
              break;
          }
          if ($data['package']['cost'] > 0) {
            $info = str_replace(array(
              '{cost}',
              '{amount}',
              '{type}'
            ), array(
              $data['package']['cost'],
              $data['package']['fixed'],
              $t
            ), $data['lang'][20]);
          } else {
            $info = str_replace(array(
              '{type}'
            ), array(
              $data['package']['fixed'] . ' ' . $t
            ), $data['lang2'][24]);
          }
        } else {
          if ($data['package']['cost'] > 0) {
            $info = str_replace(array(
              '{cost}'
            ), array(
              $data['package']['cost']
            ), $data['lang'][27]);
          } else {
            $info = $data['lang2'][23];
          }
        }
        break;
      case 'subscr':
        $type = ($data['package']['rentype'] == 'days' ? $data['lang'][12] : ($data['package']['rentype'] == 'months' ? $data['lang'][13] : $data['lang'][14]));
        $info = str_replace(array(
          '{cost}',
          '{amount}',
          '{rentype}'
        ), array(
          $data['package']['cost'],
          $data['package']['renewal'],
          $type
        ), $data['lang'][21]);
        break;
    }
    return $info;
  }

  public function package($data = array()) {
    $Q       = db::db_query("SELECT * FROM `" . DB_PREFIX . "packages` WHERE `id` = '{$data['id']}'");
    $PACKAGE = db::db_object($Q);
    return (isset($PACKAGE->id) ? $PACKAGE : '');
  }

  public function logger() {
    $log = '';
    if ($this->settings->responselog == 'yes') {
      $message = date('j F Y H:i:s') . mswDefineNewline();
      $message .= $this->server() . mswDefineNewline();
      $message .= '- - - - - - - - - - - - - - - - - - - -' . mswDefineNewline();
      foreach ($_POST AS $key => $value) {
        $message .= $key . ': ' . mswCleanRawData($value) . mswDefineNewline();
      }
      $message .= '= = = = = = = = = = = = = = = = = = = =' . mswDefineNewline();
      $log = LOG_FOLDER . '/' . $this->gateway . '.txt';
      if (is_dir(PATH . LOG_FOLDER) && is_writeable(PATH . LOG_FOLDER)) {
        file_put_contents($log, ltrim($message), FILE_APPEND);
      }
      return $log;
    }
  }

  public function ssl() {
    return (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 'yes' : 'no');
  }

}

?>