<?php

class paypal extends processor {

  public function payment() {
    $add = array();
    foreach (array('payer_business_name','payer_business_name','address_street','address_city','address_state','address_zip','','address_country') AS $addF) {
      if (isset($_POST[$addF]) && $_POST[$addF]) {
        $add[] = $_POST[$addF];
      }
    }
    return array(
      'name' => (isset($_POST['first_name'], $_POST['last_name']) ? $_POST['first_name'] . ' ' . $_POST['last_name'] : ''),
      'email' => (isset($_POST['payer_email']) ? $_POST['payer_email'] : ''),
      'trans' => (isset($_POST['subscr_id']) ? $_POST['subscr_id'] : $_POST['txn_id']),
      'address' => $add,
      'amount' => (isset($_POST['mc_amount3']) ? $_POST['mc_amount3'] : $_POST['mc_gross']),
      'currency' => (isset($_POST['mc_currency']) ? $_POST['mc_currency'] : ''),
      'inv_status' => 'approved',
      'fraud_status' => 'pass',
      'refund' => (isset($_POST['mc_gross']) ? (substr($_POST['mc_gross'], 0, 1) == '-' ? substr($_POST['mc_gross'], 1) : $_POST['mc_gross']) : ''),
      'sub_id' => (isset($_POST['subscr_id']) ? $_POST['subscr_id'] : $_POST['txn_id'])
    );
  }

  public function nextRenewalDate($data = array()) {
    switch ($data['package']['type']) {
      case 'fixed':
        $date = '0000-00-00';
        break;
      case 'subscr':
        $date = date('Y-m-d', strtotime('+' . $data['package']['renewal'] . ' ' . $data['package']['rentype']));
        break;
    }
    switch ($data['formatted']) {
      case 'no':
        if ($data['return'] == 'no') {
          db::db_query("UPDATE `" . DB_PREFIX . "members` SET
          `nextrenewdate` = '{$date}'
          WHERE `id`      = '{$data['order']}'
          ");
        } else {
          return $date;
        }
        break;
      case 'yes':
        return (strtotime($date) > 0 ? date($this->settings->dateformat, strtotime($date)) : $data['lang'][23]);
        break;
    }
  }

  public function validate() {
    $url    = paypal::server();
    $fields = http_build_query($_POST) . '&cmd=_notify-validate';
    $ch     = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; www.' . SCRIPT_URL . '; ' . SCRIPT_NAME . ' Handler)');
    curl_setopt($ch, CURLOPT_HEADER, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_TIMEOUT, 120);
    $r = curl_exec($ch);
    curl_close($ch);
    return (strpos(strtolower($r), 'verified') === true || strpos(strtolower($r), 'verified') > 0 ? 'OK' : 'ERR');
  }

  public function fields($data = array()) {
    $html = '';
    $url  = (processor::ssl() == 'yes' ? str_replace('http://', 'https://', $this->settings->httppath) : $this->settings->httppath);
    switch ($data['package']['type']) {
      case 'fixed':
        $fields = array(
          'rm' => '2',
          'cmd' => '_xclick',
          'business' => $this->payoptions->pp_email,
          'item_name' => mswCleanData($data['package']['name']),
          'quantity' => '1',
          'notify_url' => $url . 'paypal.php',
          'cancel_return' => $url . 'paypal.php?cancel=yes',
          'return' => $url . 'paypal.php?return=' . $data['member']['gencode'] . '-' . $data['member']['id'],
          'amount' => $data['package']['cost'],
          'no_shipping' => '1',
          'currency_code' => $data['package']['currency'],
          'custom' => $data['member']['gencode'] . '-' . $data['member']['id'] . '-mswlockbox' . ($data['restart'] == 'yes' ? '-r' : ''),
          'page_style' => ($this->payoptions->pp_style ? $this->payoptions->pp_style : 'paypal'),
          'lc' => ($this->payoptions->pp_locale ? $this->payoptions->pp_locale : 'US')
        );
        break;
      case 'subscr':
        $fields = array(
          'rm' => '2',
          'cmd' => '_xclick-subscriptions',
          'business' => $this->payoptions->pp_email,
          'item_name' => mswCleanData($data['package']['name']),
          'notify_url' => $url . 'paypal.php',
          'cancel_return' => $url . 'paypal.php?cancel=yes',
          'return' => $url . 'paypal.php?return=' . $data['member']['gencode'] . '-' . $data['member']['id'],
          'a3' => $data['package']['cost'],
          'p3' => $data['package']['renewal'],
          't3' => strtoupper(substr($data['package']['rentype'], 0, 1)),
          'src' => '1',
          'sra' => '1',
          'modify' => '0',
          'currency_code' => $data['package']['currency'],
          'no_note' => '1',
          'custom' => $data['member']['gencode'] . '-' . $data['member']['id'] . '-mswlockbox' . ($data['restart'] == 'yes' ? '-r' : ''),
          'page_style' => ($this->payoptions->pp_style ? $this->payoptions->pp_style : 'paypal'),
          'lc' => ($this->payoptions->pp_locale ? $this->payoptions->pp_locale : 'US')
        );
        break;
    }
    // Live or test mode..
    if ($this->settings->paymode == 'test') {
      $fields['test_ipn'] = '1';
    }
    // Additional..
    if (!empty($data['gw_inclusions'])) {
      $fields = array_merge($fields, $data['gw_inclusions']);
    }
    // Build field data..
    foreach ($fields AS $name => $value) {
      $html .= '<input type="hidden" name="' . mswSafeDisplay($name) . '" value="' . mswSafeDisplay($value) . '">' . mswDefineNewline();
    }
    return rtrim($html);
  }

  public function pending($data = array()) {
    return (isset($data['paypend'][$_POST['pending_reason']]) ? $data['paypend'][$_POST['pending_reason']] : $data['lang'][23]);
  }

  public function server() {
    // Legacy adjustment..
    if (substr($this->payoptions->pp_live_url,-1) == '?') {
      $this->payoptions->pp_live_url = substr($this->payoptions->pp_live_url, 0, -1);
    }
    if (substr($this->payoptions->pp_sand_url,-1) == '?') {
      $this->payoptions->pp_sand_url = substr($this->payoptions->pp_sand_url, 0, -1);
    }
    return ($this->settings->paymode == 'test' ? $this->payoptions->pp_sand_url . '?' : $this->payoptions->pp_live_url . '?');
  }

  public function enabled() {
    return $this->payoptions->pp_enable;
  }

}

?>