<?php

if (!defined('PARENT')) {
  mswHeadCode($gblang[4], '403');
}

//---------------------------------------------------
// Theme loaders
//---------------------------------------------------

function mswThemeLoader($folder) {
  return (is_dir(ML_BASE_PATH . 'content/' . $folder) ? $folder : '_theme_default');
}

function mswPackageThemeLoader($folder, $pfolder) {
  if ($pfolder) {
    if ($pfolder != $folder && is_dir(ML_BASE_PATH . 'content/' . $pfolder)) {
      return $pfolder;
    }
  }
  return (is_dir(ML_BASE_PATH . 'content/' . $folder) ? $folder : '_theme_default');
}

//---------------------------------
// New line to break..
//---------------------------------

function mswNL2BR($text) {
  // Second param added in 5.3.0, else its not available..
  if (version_compare(phpversion(), '5.3.0', '<')) {
    return str_replace(mswDefineNewline(), '<br>', $text);
  }
  return nl2br($text, false);
}

//---------------------------------
// Query string management
//---------------------------------

function qStringBuilder($skip = array()) {
  $qstring = array();
  if (!empty($_GET)) {
    foreach ($_GET AS $k => $v) {
      if (!in_array($k, $skip)) {
        $qstring[] = $k . '=' . mswSafeDisplay(urlencode($v));
      }
    }
  }
  return (!empty($qstring) ? '&amp;' . implode('&amp;', $qstring) : '');
}

function qStringSelector($param,$value,$setvar = '') {
  if ($setvar) {
    return ($setvar == $value ? ' selected="selected"' : '');
  } else {
    return (isset($_GET[$param]) && $_GET[$param] == $value ? ' selected="selected"' : '');
  }
}

//---------------------------------------------------
// Redirect Path
//---------------------------------------------------

function mswHttpRedPath($redir, $s) {
  if ($redir) {
    // External or local..
    if (substr(strtolower($redir), 0, 5) == 'http:') {
      return $redir;
    } else {
      return $s->httppath . $redir;
    }
  } else {
    return $s->httppath;
  }
}

//---------------------------------------------------
// Fixes settings fields if manual schema was run..
//---------------------------------------------------

function mswManualSchemaFix($admin = false) {
  $DB = new db();
  if ($SETTINGS->httppath == '' && $SETTINGS->prodkey == '' && $SETTINGS->timezone == '') {
    $softwarePath = 'http://www.example.co.uk/lockbox';
    if (isset($_SERVER['HTTP_HOST']) && isset($_SERVER['PHP_SELF'])) {
      if ($admin) {
        $softwarePath = 'http' . (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '') . '://' . $_SERVER['HTTP_HOST'] . substr($_SERVER['PHP_SELF'], 0, strpos($_SERVER['PHP_SELF'], ADMIN_FOLDER) - 1) . '/';
      } else {
        $softwarePath = 'http' . (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '') . '://' . $_SERVER['HTTP_HOST'] . substr($_SERVER['PHP_SELF'], 0, -10) . '/';
      }
    }
    $DB->db_query("UPDATE `" . DB_PREFIX . "settings` SET
    `httppath`       = '$softwarePath',
    `timezone`       = '" . date_default_timezone_get() . "',
    `encoder`        = 'msw',
    `version`        = '" . SCRIPT_VERSION . "'
    ");
    // Page reload..
    header("Location: index.php");
    exit;
  }
}

//---------------------------------------------------
// Block checker
//---------------------------------------------------

function mswBlockChecker($type, $data = '') {
  $field = 'block_' . $type;
  $ips   = mswGetRealIPAddr(true);
  if (isset($SETTINGS->$field)) {
    $arr = ($SETTINGS->$field ? explode(mswDefineNewline(), rtrim($SETTINGS->$field)) : array());
    if (!empty($arr)) {
      // Clear whitespace and convert to lowercase..
      $arr = array_map('trim', $arr);
      switch ($type) {
        // Check IP address..
        case 'ip':
          if (is_array($ips) && !empty($ips)) {
            foreach ($arr AS $d) {
              if (substr($d, 0, 1) == '*') {
                $entry = strtolower(substr($d, 1));
              } else {
                $entry = strtolower($d);
              }
              foreach ($ips AS $ipAddress) {
                if (strpos($ipAddress, $entry) !== false || $entry == $ipAddress) {
                  return 'fail';
                }
              }
            }
          }
          break;
        // Check username/email..
        default:
          foreach ($arr AS $d) {
            if (substr($d, 0, 1) == '*') {
              $entry = strtolower(substr($d, 1));
              if (strpos($data, $entry) !== false) {
                return 'fail';
              }
            } else {
              if (strtolower($d) == strtolower($data)) {
                return 'fail';
              }
            }
          }
          break;
      }
    }
  }
  return 'ok';
}

//---------------------------------------------------
// Valid mail checker
//---------------------------------------------------

function mswMailChecker($em) {
  if ($em == '') {
    return 'no';
  } else {
    if (function_exists('filter_var') && !filter_var($em, FILTER_VALIDATE_EMAIL)) {
      return 'no';
    } else {
      if (!preg_match("/^[_.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z.-]+.)+[a-zA-Z]{2,6}$/i", $em)) {
        return 'no';
      }
    }
  }
  return 'ok';
}

//---------------------------------------------------
// Event logger
//---------------------------------------------------

function mswEventLog($data = array(), $dt, $obj, $s) {
  $p   = (!empty($data['prefs']) ? $data['prefs'] : array());
  $p[] = 'free';
  $now = $dt->utcTime();
  if (in_array($data['type'], $p) && in_array($data['type'], array(
    'login',
    'payment',
    'admin',
    'free'
  )) && $data['action'] && $s->eventlog == 'yes') {
    $obj->db_query("INSERT INTO `" . DB_PREFIX . "eventlog` (
    `member`,
    `ip`,
    `ts`,
    `action`,
    `type`,
    `notes`
    ) VALUES (
    '{$data['member']}',
    '" . ($data['ip'] ? $data['ip'] : mswGetRealIPAddr()) . "',
    '{$now}',
    '" . mswSafeString($data['action'], $obj) . "',
    '{$data['type']}',
    '" . mswSafeString($data['notes'], $obj) . "'
    )");
  }
}

//---------------------------------------------------
// Set timezone
//---------------------------------------------------

function mswSetTimeZone($timezone) {
  date_default_timezone_set($timezone);
}

//---------------------------------------------------
// Connection error
//---------------------------------------------------

function mswMySQLError($code, $error, $file, $line) {
  echo '<p style="color:red;border:2px solid red;padding:10px;font-size:12px;line-height:20px;background:#f2f2f2">';
  echo '<b style="color:black">MYSQL DATABASE ERROR:</b><br>';
  echo '<b>' . (isset($gblang[5][0]) ? $gblang[5][0] : 'Code') . '</b>: ' . $code . '<br>';
  echo '<b>' . (isset($gblang[5][1]) ? $gblang[5][1] : 'Error') . '</b>: ' . $error . '<br>';
  echo '<b>' . (isset($gblang[5][2]) ? $gblang[5][2] : 'File') . '</b>: ' . $line . '<br>';
  echo '<b>' . (isset($gblang[5][3]) ? $gblang[5][3] : 'Line') . '</b>: ' . $file . '<br>';
  echo '</p>';
  exit;
}

//---------------------------------------------------
// Cleans output data..
//---------------------------------------------------

function mswCleanData($data) {
  if (function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc()) {
    $sybase = strtolower(@ini_get('magic_quotes_sybase'));
    if (empty($sybase) || $sybase == 'off') {
      // Fixes issue of new line chars not parsing between single quotes..
      $data = str_replace('\n', '\\\n', $data);
      return stripslashes($data);
    }
  }
  return $data;
}

//---------------------------------------------------
// Auto purge dead members
//---------------------------------------------------

function mswAutoPurge($s, $obj) {
  $m = array();
  if ($s->autoclear > 0) {
    // Dead members..
    $obj->db_query("DELETE FROM `" . DB_PREFIX . "members`
    WHERE `status`  = 'pay'
    AND DATEDIFF(NOW(), `joined`) >= " . $s->autoclear
    );
  }
  // Clean event log, this runs all the time..
  $obj->db_query("DELETE FROM `" . DB_PREFIX . "eventlog` WHERE `member` = '0'");
  $q = $obj->db_query("SELECT `member` FROM `" . DB_PREFIX . "eventlog`
       WHERE (SELECT count(*) FROM `" . DB_PREFIX . "members` WHERE `" . DB_PREFIX . "members`.`id` = `" . DB_PREFIX . "eventlog`.`member`) = 0
       GROUP BY `" . DB_PREFIX . "eventlog`.`member`
       ");
  while ($dm = $obj->db_object($q)) {
    $m[] = $dm->member;
  }
  if (!empty($m)) {
    // Dead members for event log..
    $obj->db_query("DELETE FROM `" . DB_PREFIX . "eventlog`
    WHERE `member` IN(" . implode(',', $m) . ")
    ");
  }
}

//----------------------------
// DB Schema..
//----------------------------

function mswDBSchemaArray($db) {
  $tbl = array();
  if (strlen(DB_PREFIX) > 0) {
    $q = $db->db_query("SHOW TABLES WHERE SUBSTRING(`Tables_in_" . DB_NAME . "`,1," . strlen(DB_PREFIX) . ") = '" . DB_PREFIX . "'");
  } else {
    $q = $db->db_query("SHOW TABLES");
  }
  while ($TABLES = $db->db_object($q)) {
    $field = 'Tables_in_' . DB_NAME;
    $tbl[] = $TABLES->{$field};
  }
  return $tbl;
}

//---------------------------------------------------
// Cleans output data with character entities..
//---------------------------------------------------

function mswSafeDisplay($data) {
  $data = htmlspecialchars($data);
  $data = str_replace('&amp;#', '&#', $data);
  $data = str_replace('&amp;amp;', '&amp;', $data);
  return mswCleanData($data);
}

//---------------------------------------------------
// Cleans output data without amendments..
//---------------------------------------------------

function mswCleanRawData($data) {
  if (function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc()) {
    $sybase = strtolower(@ini_get('magic_quotes_sybase'));
    if (empty($sybase) || $sybase == 'off') {
      // Fixes issue of new line chars not parsing between single quotes..
      $data = str_replace('\n', '\\\n', $data);
      return stripslashes($data);
    }
  }
  return $data;
}

//---------------------------------------------------
// Format currency display..
//---------------------------------------------------

function mswCurrencyFormat($p, $f) {
  return str_replace(array('{PRICE}','{AMOUNT}'), mswFormatPrice($p), $f);
}

//---------------------------------------------------
// Format price..
//---------------------------------------------------

function mswFormatPrice($price, $comma = false) {
  $sep = '';
  if (PRICE_THOUSANDS_SEPERATORS && $comma) {
    $sep = PRICE_THOUSANDS_SEPERATORS;
  }
  $price = @number_format($price, 2, '.', '');
  $price = preg_replace("/[^0-9\.]/", "", str_replace(',', '.', $price));
  if (substr($price, -3, 1) == '.') {
    $pennies = '.' . substr($price, -2);
    $price   = substr($price, 0, strlen($price) - 3);
  } elseif (substr($price, -2, 1) == '.') {
    $pennies = '.' . substr($price, -1);
    $price   = substr($price, 0, strlen($price) - 2);
  } else {
    $pennies = '.00';
  }
  $price = preg_replace("/[^0-9]/", "", $price);
  // Prevent formatting errors during imports..
  if ($price == '') {
    $price = '0';
  }
  if (rtrim($pennies, '.') == '') {
    $pennies = '.00';
  }
  return ($price . $pennies > 0 ? @number_format($price . $pennies, 2, '.', ($sep ? $sep : '')) : '0.00');
}

//---------------------------------------------------
// Generates 60 character product key..
//---------------------------------------------------

function mswGenerateProductKey() {
  $_SERVER['HTTP_HOST']   = (isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST'] ? $_SERVER['HTTP_HOST'] : uniqid(rand(), 1));
  $_SERVER['REMOTE_ADDR'] = (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] ? $_SERVER['REMOTE_ADDR'] : uniqid(rand(), 1));
  if (function_exists('sha1')) {
    $c1      = sha1($_SERVER['HTTP_HOST'] . date('YmdHis') . $_SERVER['REMOTE_ADDR'] . time());
    $c2      = sha1(uniqid(rand(), 1) . time());
    $prodKey = substr($c1 . $c2, 0, 60);
  } elseif (function_exists('md5')) {
    $c1      = md5($_SERVER['HTTP_POST'] . date('YmdHis') . $_SERVER['REMOTE_ADDR'] . time());
    $c2      = md5(uniqid(rand(), 1), time());
    $prodKey = substr($c1 . $c2, 0, 60);
  } else {
    $c1      = str_replace('.', '', uniqid(rand(), 1));
    $c2      = str_replace('.', '', uniqid(rand(), 1));
    $c3      = str_replace('.', '', uniqid(rand(), 1));
    $prodKey = substr($c1 . $c2 . $c3, 0, 60);
  }
  return strtoupper($prodKey);
}

//---------------------------------------------------
// Clean form input..
//---------------------------------------------------

function mswCleanEvilTags($data) {
  $data = preg_replace("/javascript/i", "j&#097;v&#097;script", $data);
  $data = preg_replace("/about:/i", "&#097;bout:", $data);
  $data = preg_replace("/onmouseover/i", "&#111;nmouseover", $data);
  $data = preg_replace("/onclick/i", "&#111;nclick", $data);
  $data = preg_replace("/onload/i", "&#111;nload", $data);
  $data = preg_replace("/onsubmit/i", "&#111;nsubmit", $data);
  $data = preg_replace("/<body/i", "&lt;body", $data);
  $data = preg_replace("/<html/i", "&lt;html", $data);
  $data = preg_replace("/document\./i", "&#100;ocument.", $data);
  return strip_tags(trim($data));
}

//---------------------------------------------------
// Define new line per op system..
//---------------------------------------------------

function mswDefineNewline() {
  if (defined('PHP_EOL')) {
    return PHP_EOL;
  }
  if (isset($_SERVER["HTTP_USER_AGENT"]) && strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'win')) {
    $newline = "\r\n";
  } else if (isset($_SERVER["HTTP_USER_AGENT"]) && strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'mac')) {
    $newline = "\r";
  } else {
    $newline = "\n";
  }
  return $newline;
}

//---------------------------------------------------
// File size..
//---------------------------------------------------

function mswFileSizeConversion($size = 0, $precision = 2) {
  if ($size > 0) {
    $base     = log($size) / log(1024);
    $suffixes = array(
      'Bytes',
      'KB',
      'MB',
      'GB',
      'TB'
    );
    return round(pow(1024, $base - floor($base)), $precision) . $suffixes[floor($base)];
  } else {
    return '0Bytes';
  }
}

//---------------------------------------------------
// Gets visitor IP address..
//---------------------------------------------------

function mswGetRealIPAddr($array = false) {
  $ip = array();
  if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
    $ip[] = $_SERVER['HTTP_CLIENT_IP'];
  } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    if (strpos($_SERVER['HTTP_X_FORWARDED_FOR'], ',') !== FALSE) {
      $split = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
      foreach ($split AS $value) {
        $ip[] = $value;
      }
    } else {
      $ip[] = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }
  } else {
    $ip[] = $_SERVER['REMOTE_ADDR'];
  }
  if ($array) {
    return $ip;
  } else {
    return (!empty($ip) ? implode(',', $ip) : '');
  }
}

//---------------------------------------------------
// Returns encrypted data..
//---------------------------------------------------

function mswEncrypt($data) {
  return (function_exists('sha1') ? sha1($data) : md5($data));
}

//---------------------------------------------------
// Safe mysql import..
//---------------------------------------------------

function mswSafeImport($data) {
  if (function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc()) {
    $sybase = strtolower(@ini_get('magic_quotes_sybase'));
    if (empty($sybase) || $sybase == 'off') {
      $data = mswMultiDimensionalArrayMap('stripslashes', $data);
    } else {
      $data = mswMultiDimensionalArrayMap('mswRemoveDoubleApostrophes', $data);
    }
  }
  $data = mswMultiDimensionalArrayMap('mysqli_real_escape_string', $data);
  return $data;
}

//---------------------------------------------------
// Safe import string..
//---------------------------------------------------

function mswSafeString($data, $obj) {
  if (function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc()) {
    $sybase = strtolower(@ini_get('magic_quotes_sybase'));
    if (empty($sybase) || $sybase == 'off') {
      $data = stripslashes($data);
    } else {
      $data = mswRemoveDoubleApostrophes($data);
    }
  }
  return $obj->db_escape($data);
}

//---------------------------------------------------
// Get status
//---------------------------------------------------

function mswGetStatus($flag, $l) {
  return ($flag == 'yes' ? '<i class="fa fa-check-square fa-fw ml_green" title="' . mswSafeDisplay($l[34]) . '"></i>' : '<i class="fa fa-times-circle fa-fw ml_red" title="' . mswSafeDisplay($l[35]) . '"></i>');
}

//---------------------------------------------------
// Get browser type..
//---------------------------------------------------

function mswGetBrowserType() {
  $agent = 'IE';
  if (isset($_SERVER['HTTP_USER_AGENT'])) {
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'OPERA') !== FALSE) {
      $agent = 'OPERA';
    } elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== FALSE) {
      $agent = 'IE';
    } elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'OMNIWEB') !== FALSE) {
      $agent = 'OMNIWEB';
    } elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'MOZILLA') !== FALSE) {
      $agent = 'MOZILLA';
    } elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'KONQUEROR') !== FALSE) {
      $agent = 'KONQUEROR';
    } else {
      $agent = 'OTHER';
    }
  }
  return $agent;
}

//---------------------------------------------------
// Get mime type..
//---------------------------------------------------

function mswGetMimeType() {
  $agent     = mswGetBrowserType();
  $mime_type = ($agent == 'IE' || $agent == 'OPERA') ? 'application/octetstream' : 'application/octet-stream';
  return $mime_type;
}

//---------------------------------------------------
// Quote/apostrophe stripper..
//---------------------------------------------------

function mswRemoveDoubleApostrophes($data) {
  return str_replace("''", "'", $data);
}

function mswQuoteStripper($data) {
  return str_replace(array(
    '"',
    "'"
  ), array(), $data);
}

//---------------------------------------------------
// Recursive way of handling multi dimensional arrays..
//---------------------------------------------------

function mswMultiDimensionalArrayMap($func, $arr) {
  $newArr = array();
  if (!empty($arr)) {
    foreach ($arr AS $key => $value) {
      $newArr[$key] = (is_array($value) ? mswMultiDimensionalArrayMap($func, $value) : $func($value));
    }
  }
  return $newArr;
}

//---------------------------------------------------
// Forbidden
//---------------------------------------------------

function mswHeadCode($msg, $code) {
  switch ($code) {
    case '200':
      header('HTTP/1.0 200 OK');
      break;
    case '400':
      header('HTTP/1.0 400 Bad Request');
      break;
    case '403':
      header('HTTP/1.0 403 Forbidden');
      break;
    case '404':
      header('HTTP/1.0 404 Not Found');
      break;
  }
  header('content-type: text/plain; charset=utf-8');
  echo $msg;
  exit;
}

//-----------------------------------
// Auto Expire
//-----------------------------------

function mswAdminAutoExpire($dt, $db, $lang, $s) {
  $mems = array(array(), array());
  $now  = $dt->utcTime();
  // Fixed...
  $Q    = $db->db_query("SELECT `id`, `eventlog` FROM `" . DB_PREFIX . "members`
         WHERE `status`     = 'active'
         AND `fixedexpiry`  > 0
         AND `fixedtimer`   > 0
         AND `fixedexpiry` <= '{$now}'
         ORDER BY `id`
         ");
  while ($M = $db->db_object($Q)) {
    $mems[0][] = $M->id;
    mswEventLog(array(
      'member' => $M->id,
      'action' => $lang[1],
      'prefs' => ($M->eventlog ? unserialize($M->eventlog) : array()),
      'type' => 'auto',
      'notes' => '',
      'ip' => mswGetRealIPAddr()
    ), $dt, $db, $s);
  }
  if (!empty($mems[0])) {
    $db->db_query("UPDATE `" . DB_PREFIX . "members` SET
    `status`    = 'expired'
    WHERE `id` IN(" . implode(',', $mems[0]) . ")
    ");
  }
  // Subcriptions...
  $Q = $db->db_query("SELECT `id`, `eventlog` FROM `" . DB_PREFIX . "members`
         WHERE `status`        = 'active'
         AND `nextrenewdate`  != '0000-00-00'
         AND `nextrenewdate`   < '" . date('Y-m-d') . "'
         ORDER BY `id`
         ");
  while ($M = $db->db_object($Q)) {
    $mems[1][] = $M->id;
    mswEventLog(array(
      'member' => $M->id,
      'action' => $lang[25],
      'prefs' => ($M->eventlog ? unserialize($M->eventlog) : array()),
      'type' => 'auto',
      'notes' => '',
      'ip' => mswGetRealIPAddr()
    ), $dt, $db, $s);
  }
  if (!empty($mems[1])) {
    $db->db_query("UPDATE `" . DB_PREFIX . "members` SET
    `status`    = 'renew'
    WHERE `id` IN(" . implode(',', $mems[1]) . ")
    ");
  }
}

//-----------------------------------
// Filter statuses
//-----------------------------------

function mswMemberFilterStatuses($approve = true, $lang = array()) {
  $arr = array(
    'active' => $lang[8],
    'disabled' => $lang[9],
    'expired' => $lang[59],
    'renew' => $lang[48],
    'apay' => $lang[47],
    'approve' => $lang[69],
    'rapprove' => $lang[70],
    'stopped' => $lang[68],
    'failed' => $lang[66],
    'refunded' => $lang[67]
  );
  // If approved are not to be shown, remove them..
  if (!$approve) {
    unset($arr['approve'], $arr['rapprove']);
  }
  return $arr;
}

//-----------------------------------
// Statuses
//-----------------------------------

function mswMemberStatuses() {
  return array(
    "'active'",
    "'renew'",
    "'apay'",
    "'disabled'",
    "'expired'",
    "'stopped'",
    "'refunded'",
    "'failed'"
  );
}

//-----------------------------------
// Package payment detail
//-----------------------------------

function mswPkgDetail($data = array()) {
  switch ($data['package']['type']) {
    case 'fixed':
      if ($data['package']['fixedtype'] != 'none') {
        switch ($data['package']['fixedtype']) {
          case 'mins':
            $t = $data['lang'][25];
            break;
          case 'hours':
            $t = $data['lang'][26];
            break;
          case 'days':
            $t = $data['lang'][12];
            break;
          case 'months':
            $t = $data['lang'][13];
            break;
          case 'years':
            $t = $data['lang'][14];
            break;
        }
        if ($data['package']['cost'] > 0) {
          $info = str_replace(array(
            '{cost}',
            '{amount}',
            '{type}'
          ), array(
            $data['package']['cost'],
            $data['package']['fixed'],
            $t
          ), $data['lang'][20]);
        } else {
          $info = str_replace(array(
            '{cost}',
            '{amount}',
            '{type}'
          ), array(
            $data['package']['cost'],
            $data['package']['fixed'],
            $t
          ), $data['lang'][66]);
        }
      } else {
        $info = str_replace(array(
          '{cost}'
        ), array(
          $data['package']['cost'],
          $data['package']['curdisplay']
        ), $data['lang'][27]);
      }
      break;
    case 'subscr':
      $type = ($data['package']['rentype'] == 'days' ? $data['lang'][12] : ($data['package']['rentype'] == 'months' ? $data['lang'][13] : $data['lang'][14]));
      $info = str_replace(array(
        '{cost}',
        '{amount}',
        '{rentype}'
      ), array(
        $data['package']['cost'],
        $data['package']['renewal'],
        $type
      ), $data['lang'][21]);
      break;
  }
  return $info;
}

//-----------------------------------
// Determine which doc topic to load
//-----------------------------------

function mswDocTopic($cmd) {
  switch ($cmd) {
    case 'purchase':
      return 'index';
      break;
    case 'msg':
      return ($_GET['code'] == 'test' ? 'ad-test' : 'index');
      break;
    default:
      return 'ad-' . $cmd . (isset($_GET['gateway']) && in_array($_GET['gateway'], array(
        'paypal',
        '2checkout'
      )) ? '-' . $_GET['gateway'] : '');
      break;
  }
}

//------------------------------------
// Table truncation routine
//------------------------------------

function mswTableTruncationRoutine($tables = array(), $obj) {
  if (!empty($tables)) {
    foreach ($tables AS $t) {
      if ($obj->db_rowcount($t) == 0) {
        $obj->db_query("TRUNCATE TABLE `" . DB_PREFIX . $t . "`");
      }
    }
  }
}

//-----------------------------------------------
// Controller
//-----------------------------------------------

function mswfileController() {
  if (!file_exists(ML_BASE_PATH . 'control/system/core/sys-controller.php')) {
    die('[FATAL ERROR] The "control/system/core/sys-controller.php" file does NOT exist in your installation. It may have been auto deleted by your anti virus software. If
    this is the case, this is a false positive. Please add the file to your anti virus whitelist, re-add and refresh page.');
  }
}

//---------------------------------------------------
// Global filtering on post and get input..
//---------------------------------------------------

$_GET  = mswMultiDimensionalArrayMap('mswCleanEvilTags', $_GET);
$_GET  = mswMultiDimensionalArrayMap('mswQuoteStripper', $_GET);
$_GET  = mswMultiDimensionalArrayMap('htmlspecialchars', $_GET);
$_POST = mswMultiDimensionalArrayMap('trim', $_POST);

?>