<?php

if (!defined('PARENT')) {
  mswHeadCode($gblang[4], '403');
}

//---------------------------------------------------
// Load language files..
//---------------------------------------------------

include(PATH . 'content/language/global.php');
include(PATH . 'content/language/js.php');
include(PATH . 'content/language/admin.php');
include(PATH . 'content/language/public.php');

//---------------------------------------------------
// Load include files..
//---------------------------------------------------

include(PATH . 'control/timezones.php');
include(PATH . 'control/functions.php');
include(PATH . 'control/constants.php');

//---------------------------------------------------
// Database connection..
//---------------------------------------------------

include(PATH . 'control/connect.php');
include(PATH . 'control/classes/class.db.php');
$DB = new db();
$DB->db_conn();

//----------------------------
// Savant template engine..
//----------------------------

include(PATH . 'control/lib/Savant3.php');

//---------------------------------------------------
// Load class files..
//---------------------------------------------------

mswfileController();
include(PATH . 'control/system/core/sys-controller.php');
include(PATH . 'control/classes/class.datetime.php');
include(PATH . 'control/classes/class.page.php');
include(PATH . 'control/classes/class.json.php');
include(PATH . 'control/classes/class.processor.php');
include(PATH . 'control/classes/class.ht.php');

//---------------------------------------------------
// Declare and initialise..
//---------------------------------------------------

$JSON  = new jsonHandler();
$HTA   = new htAccessControl();
$DT    = new mlDateTime();
$BOXHD = new processor();

//---------------------------------------------------
// Load settings..
//---------------------------------------------------

$Q    = $DB->db_query("SELECT * FROM `" . DB_PREFIX . "settings`");
$QGW  = $DB->db_query("SELECT * FROM `".DB_PREFIX."gateways`");

if ($Q == 'err') {
  header("Location: ../install/index.php");
  exit;
}

$SETTINGS          = $DB->db_object($Q);
$GATEHD            = $DB->db_object($QGW);
$HTA->settings     = $SETTINGS;
$DT->settings      = $SETTINGS;
$BOXHD->settings   = $SETTINGS;
$BOXHD->payoptions = $GATEHD;
$BOXHD->datetime   = $DT;

//---------------------------------------------------
// Theme loader
//---------------------------------------------------

define('THEME', mswThemeLoader($SETTINGS->theme));

//---------------------------------------------------
// Set timezone..
//---------------------------------------------------

$DT->setTimeZone($SETTINGS->timezone, $timezones);

//---------------------------------------------------
// IP block check
//---------------------------------------------------

if (mswBlockChecker('ip') == 'fail' && isset($_SERVER['PHP_SELF']) &&
    basename($_SERVER['PHP_SELF']) != 'redirects.php' && !isset($_GET['ajax'])) {
  header("Location: redirects.php?p=ip-block");
  exit;
}

//---------------------------------------------------
// Variables
//---------------------------------------------------

$eString = array();
$p       = (isset($_GET['p']) ? $_GET['p'] : '');

//---------------------------------------------------
// Ajax Handler
//---------------------------------------------------

if (isset($_GET['ajax'])) {
  include(PATH . 'control/system/ajax.php');
  exit;
}

?>