<?php

header('Expires: Sun, 01 Jan 2014 00:00:00 GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');
header('Content-type: text/html; charset=utf-8');

define('PATH', dirname(__FILE__) . '/');
define('PARENT', 1);
define('LOADFILE', basename(__file__));
define('PACKAGE', (isset($_GET['package']) ? (int) $_GET['package'] : '0'));

// DEFINED..
include(PATH . 'control/defined.php');

// ERROR REPORTING..
include(PATH . 'control/classes/class.errors.php');
if (ERR_HANDLER_ENABLED) {
  register_shutdown_function('msFatalErr');
  set_error_handler('msErrorhandler');
}

// INITIALISE..
include(PATH . 'control/init.php');

include(PATH . 'control/mail.php');
include(PATH . 'control/classes/payments/inclusions/paypal.php');
include(PATH . 'control/classes/payments/class.paypal.php');

$BOXHD             = new paypal();
$BOXHD->settings   = $SETTINGS;
$BOXHD->payoptions = $GATEHD;
$BOXHD->gateway    = 'paypal';
$BOXHD->datetime   = $DT;

// Choose username/password..
if (PACKAGE > 0) {
  // Is this method enabled?
  if ($BOXHD->enabled() == 'no') {
    mswHeadCode($gblang[4], '403');
  }
  $PACKAGE = $BOXHD->package(array(
    'id' => PACKAGE
  ));
  if (isset($PACKAGE->id)) {
    $BOX = $BOXHD->box($PACKAGE->lockbox);
    if (isset($BOX->id)) {
      $browserTitle = str_replace(array(
        '{website}',
        '{lockbox}'
      ), array(
        mswSafeDisplay($SETTINGS->website),
        mswSafeDisplay($BOX->name)
      ), $pblang2[0]);
      include(PATH . 'control/system/start.php');
    } else {
      mswHeadCode($gblang[4], '403');
    }
  } else {
    mswHeadCode($gblang[4], '403');
  }
}

// Send to gateway..
if (isset($_GET['loading'])) {
  $CHOP    = explode('-', $_GET['loading']);
  $reStart = 'no';
  // Check for subscription re-start..
  if (isset($CHOP[1]) && substr($CHOP[1], 0, 4) == 'res_') {
    $CHOP[1] = substr($CHOP[1], 4);
    $reStart = 'yes';
  }
  if (isset($CHOP[0]) && $CHOP[0] > 0 && isset($CHOP[1]) && ctype_alnum($CHOP[1])) {
    $MEMBER = $BOXHD->member(array(
      'loader' => $CHOP[1],
      'id' => $CHOP[0],
      'auth' => ''
    ));
    if (isset($MEMBER->id)) {
      $_GET['package'] = $MEMBER->package;
      $PACKAGE         = $BOXHD->package(array(
        'id' => $MEMBER->package
      ));
      $browserTitle    = mswSafeDisplay($pblang3[0]);
      include(PATH . 'control/system/pay.php');
    } else {
      mswHeadCode($gblang[4], '403');
    }
  } else {
    mswHeadCode($gblang[4], '403');
  }
}

// Cancelled..
if (isset($_GET['cancel'])) {
  $browserTitle = mswSafeDisplay($pblang3[4]);
  include(PATH . 'control/system/cancel.php');
}

// Check return..
if (isset($_GET['return'])) {
  include(PATH . 'control/system/check-response.php');
}

// Paypal payment handling..
if (isset($_POST['custom'])) {
  // DEBUG..
  $BOXHD->debugHandler(array(
    'text' => 'Receiving transmission from gateway',
    'gateway' => $BOXHD->gateway,
    'finish' => 'no'
  ));
  // [0] = Buy Code
  // [1] = Insert ID
  // [2] = Lockbox var
  $CUSTOM = explode('-', $_POST['custom']);
  // Log if enabled..
  $log    = $BOXHD->logger();
  // Paypal response..
  $response = $BOXHD->validate();
  // Load gateway info..
  $GATEWAY  = $BOXHD->payment();
  // Handle response..
  if ($response == 'ERR') {
    // DEBUG..
    $BOXHD->debugHandler(array(
      'text' => 'Invalid response, process terminated (' . $response . ')',
      'gateway' => $BOXHD->gateway,
      'finish' => 'yes'
    ));
    $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/failed.txt'), $f_r);
    $sbj = $BOXHD->mailSubj(11);
    $mlMail->sendMail(array(
      'to_name' => $SETTINGS->website,
      'to_email' => $SETTINGS->email,
      'from_name' => $SETTINGS->website,
      'from_email' => $SETTINGS->email,
      'subject' => $sbj,
      'msg' => $mlMail->htmlWrapper(array(
        'global' => $gblang,
        'title' => $sbj,
        'header' => $sbj,
        'content' => mswNL2BR($msg),
        'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
      )),
      'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
      'other' => $SETTINGS->smtp_other,
      'plain' => $msg,
      'htmlWrap' => 'yes'
    ), $gblang);
    $mlMail->smtpClose();
  } else {
    // DEBUG..
    $BOXHD->debugHandler(array(
      'text' => 'Response OK, checking for order. . ',
      'gateway' => $BOXHD->gateway,
      'finish' => 'no'
    ));
    if (isset($CUSTOM[0], $CUSTOM[1], $CUSTOM[2]) && ctype_alnum($CUSTOM[0]) && (int) $CUSTOM[1] > 0 && $CUSTOM[2] == 'mswlockbox') {
      // Does order exist..
      $ORDER = $BOXHD->order(array(
        'id' => (int) $CUSTOM[1],
        'code' => $CUSTOM[0]
      ));
      if (isset($ORDER->id)) {
        // DEBUG..
        $BOXHD->debugHandler(array(
          'text' => 'Order found for id (' . $CUSTOM[1] . ') and code (' . $CUSTOM[0] . ')',
          'gateway' => $BOXHD->gateway,
          'finish' => 'no'
        ));
        // Package information..
        $PACKAGE = $BOXHD->package(array(
          'id' => $ORDER->package
        ));
        // DEBUG..
        if (isset($PACKAGE->id)) {
          $BOXHD->debugHandler(array(
            'text' => 'Package found for id (' . $ORDER->package . ')',
            'gateway' => $BOXHD->gateway,
            'finish' => 'no'
          ));
        } else {
          $BOXHD->debugHandler(array(
            'text' => 'Package NOT found for id (' . $ORDER->package . ')',
            'gateway' => $BOXHD->gateway,
            'finish' => 'no'
          ));
        }
        // Lockbox information..
        $BOX = $BOXHD->box($PACKAGE->lockbox);
        // DEBUG..
        if (isset($BOX->id)) {
          $BOXHD->debugHandler(array(
            'text' => 'Lockbox found for package id (' . $PACKAGE->lockbox . ')',
            'gateway' => $BOXHD->gateway,
            'finish' => 'no'
          ));
        } else {
          $BOXHD->debugHandler(array(
            'text' => 'Lockbox NOT found for package (' . $PACKAGE->lockbox . ')',
            'gateway' => $BOXHD->gateway,
            'finish' => 'no'
          ));
        }
        // Mail notification array...
        $NOTIFY = $BOXHD->emailNotify($PACKAGE->notifications);
        // Global mail tags..
        $f_r['{IP}'] = (isset($ORDER->ip) ? $ORDER->ip : 'N/A');
        $f_r['{GATEWAY}'] = ucfirst($BOXHD->gateway);
        $f_r['{PACKAGE}'] = mswCleanData($PACKAGE->name);
        $f_r['{COST}'] = $GATEWAY['amount'] . ' (' . $GATEWAY['currency'] . ')';
        $f_r['{TERMS}'] = $BOXHD->terms(array(
          'package' => (array) $PACKAGE,
          'lang' => $adlang4,
          'lang2' => $pblang2
        ));
        $f_r['{NEXT}'] = $BOXHD->nextRenewalDate(array(
          'package' => (array) $PACKAGE,
          'order' => $ORDER->id,
          'formatted' => 'yes',
          'return' => 'no',
          'lang' => $gblang
        ));
        $f_r['{BUYER}'] = $GATEWAY['name'] . mswDefineNewline() . (!empty($GATEWAY['address']) ? implode(mswDefineNewline(), $GATEWAY['address']) . mswDefineNewline() : '') . $ORDER->email;
        $f_r['{ADMIN_LOGIN}'] = $SETTINGS->httppath . ADMIN_FOLDER . '/';
        $f_r['{NAME}'] = $GATEWAY['name'];
        $f_r['{STATUS}'] = $pblang3[19];
        $f_r['{USERNAME}'] = $ORDER->username;
        $f_r['{MEMBER_LOGIN}'] = $SETTINGS->httppath . $BOX->public;
        $f_r['{SUB_ORDER_ID}'] = $GATEWAY['sub_id'];
        // Get payment status..
        if (isset($_POST['payment_status'])) {
          $paymentStatus = strtoupper($_POST['payment_status']);
          // Pending..
          if ($paymentStatus == 'pending') {
            $_POST['txn_type'] = (PAYPAL_PENDING_COMPLETED ? 'web_accept' : 'pay_pending');
          }
        }
        // Subscription re-start from link?
        if (isset($CUSTOM[3]) && $CUSTOM[3] == 'r') {
          $_POST['txn_type'] = 'subscr_modify';
        }
        // Payment status based on type..
        switch ($_POST['txn_type']) {
          case 'subscr_cancel':
            $paymentStatus = 'RECURRING_STOPPED';
            break;
          case 'subscr_eot':
            $paymentStatus = 'RECURRING_STOPPED';
            break;
          case 'subscr_failed':
            $paymentStatus = 'RECURRING_INSTALLMENT_FAILED';
            break;
          case 'subscr_signup':
            $paymentStatus = 'COMPLETED';
            break;
          case 'web_accept':
            $paymentStatus = 'COMPLETED';
            break;
          case 'subscr_payment':
            $paymentStatus = 'RECURRING_INSTALLMENT_SUCCESS';
            break;
          case 'subscr_modify':
            $paymentStatus = 'RECURRING_RESTARTED';
            break;
          case 'pay_pending':
            $paymentStatus = 'PENDING';
            break;
        }
        // DEBUG..
        $BOXHD->debugHandler(array(
          'text' => 'Processing started for status ' . $paymentStatus,
          'gateway' => $BOXHD->gateway,
          'finish' => 'no'
        ));
        // Process based on status..
        switch ($paymentStatus) {
          // Payment completed..
          case 'COMPLETED':
            if ($GATEWAY['fraud_status'] == 'pass') {
              // Check currency and amount..
              if (($GATEWAY['currency'] == $PACKAGE->currency) && ($BOXHD->currFormat($GATEWAY['amount']) >= $BOXHD->currFormat($PACKAGE->cost))) {
                // Activation. This is ignored for manual subscription restart..
                if (!isset($CUSTOM[3])) {
                  switch ($PACKAGE->appnew) {
                    case 'yes':
                      $rows = $BOXHD->activate(array(
                        'package' => (array) $PACKAGE,
                        'order' => (array) $ORDER,
                        'gateway' => $GATEWAY,
                        'action' => 'approve',
                        'lang' => $gblang
                      ));
                      $HTA->add(array(
                        'user' => $ORDER->username,
                        'pass' => '',
                        'box' => $BOX->lockbox,
                        'additional' => array(),
                        'shapass' => $ORDER->password
                      ));
                      $f_r['{STATUS}'] = $pblang3[18];
                      break;
                    case 'no':
                      $rows = $BOXHD->activate(array(
                        'package' => (array) $PACKAGE,
                        'order' => (array) $ORDER,
                        'gateway' => $GATEWAY,
                        'action' => 'active',
                        'lang' => $gblang
                      ));
                      $HTA->add(array(
                        'user' => $ORDER->username,
                        'pass' => '',
                        'box' => $BOX->lockbox,
                        'additional' => array(),
                        'shapass' => $ORDER->password
                      ));
                      $f_r['{STATUS}'] = $pblang3[19];
                      break;
                  }
                  // Send to webmaster..
                  if (in_array(3, $NOTIFY) && $rows > 0) {
                    $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-completed.txt'), $f_r);
                    $sbj = $BOXHD->mailSubj(4);
                    $mlMail->sendMail(array(
                      'to_name' => $SETTINGS->website,
                      'to_email' => $SETTINGS->email,
                      'from_name' => $GATEWAY['name'],
                      'from_email' => $ORDER->email,
                      'subject' => $sbj,
                      'msg' => $mlMail->htmlWrapper(array(
                        'global' => $gblang,
                        'title' => $sbj,
                        'header' => $sbj,
                        'content' => mswNL2BR($msg),
                        'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                      )),
                      'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                      'other' => $SETTINGS->smtp_other,
                      'plain' => $msg,
                      'htmlWrap' => 'yes'
                    ), $gblang);
                    $mlMail->smtpClose();
                  }
                  // Send to buyer..
                  if (in_array(4, $NOTIFY) && $rows > 0) {
                    $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-completed-auto.txt'), $f_r);
                    $sbj = $BOXHD->mailSubj(5);
                    $mlMail->sendMail(array(
                      'to_name' => $GATEWAY['name'],
                      'to_email' => $ORDER->email,
                      'from_name' => $SETTINGS->website,
                      'from_email' => $SETTINGS->email,
                      'subject' => $sbj,
                      'msg' => $mlMail->htmlWrapper(array(
                        'global' => $gblang,
                        'title' => $sbj,
                        'header' => $sbj,
                        'content' => mswNL2BR($msg),
                        'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                      )),
                      'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                      'plain' => $msg,
                      'htmlWrap' => 'yes'
                    ), $gblang);
                    $mlMail->smtpClose();
                  }
                  // Fixed package, clear position..
                  if ($PACKAGE->type == 'fixed') {
                    $BOXHD->updatePosition($ORDER->id);
                  }
                  // Write event log..
                  mswEventLog(array(
                    'member' => $ORDER->id,
                    'action' => $BOXHD->logMsg(array(
                      'slot' => 4,
                      'status' => '',
                      'lang' => $adlang3,
                      'loglang' => $eventlog
                    )),
                    'prefs' => ($PACKAGE->eventlog ? unserialize($PACKAGE->eventlog) : array()),
                    'type' => 'payment',
                    'notes' => '',
                    'ip' => mswGetRealIPAddr()
                  ), $DT, $DB, $SETTINGS);
                  // Additional triggers..
                  include(PATH . 'control/classes/payments/triggers/paypal.php');
                  // DEBUG..
                  $BOXHD->debugHandler(array(
                    'text' => 'Processing completed for status ' . $paymentStatus,
                    'gateway' => $BOXHD->gateway,
                    'finish' => 'yes'
                  ));
                }
              } else {
                $BOXHD->debugHandler(array(
                  'text' => 'Termination: Currency/Cost (GW:' . $GATEWAY['currency'] . '/PK:' . $PACKAGE->currency . ' || GW:' . $BOXHD->currFormat($GATEWAY['amount']) . '/PK:' . $BOXHD->currFormat($PACKAGE->cost) . ') ' . $paymentStatus,
                  'gateway' => $BOXHD->gateway,
                  'finish' => 'no'
                ));
              }
            } else {
              $BOXHD->debugHandler(array(
                'text' => 'Termination: Fraud status (' . $GATEWAY['fraud_status'] . ') ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'no'
              ));
            }
            break;
          // Recurring payment received..
          case 'RECURRING_INSTALLMENT_SUCCESS':
            if (($GATEWAY['currency'] == $PACKAGE->currency) && ($BOXHD->currFormat($GATEWAY['amount']) >= $BOXHD->currFormat($PACKAGE->cost))) {
              if ($PACKAGE->type == 'subscr' && $ORDER->position != 'start') {
                // Send to webmaster..
                if (in_array(5, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-recurring.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(7);
                  $mlMail->sendMail(array(
                    'to_name' => $SETTINGS->website,
                    'to_email' => $SETTINGS->email,
                    'from_name' => $GATEWAY['name'],
                    'from_email' => $ORDER->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'other' => $SETTINGS->smtp_other,
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                // Send to buyer..
                if (in_array(6, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-recurring-auto.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(7);
                  $mlMail->sendMail(array(
                    'to_name' => $GATEWAY['name'],
                    'to_email' => $ORDER->email,
                    'from_name' => $SETTINGS->website,
                    'from_email' => $SETTINGS->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                // Add payment..
                $BOXHD->boxPayment(array(
                  'gateway' => $GATEWAY,
                  'order' => (array) $ORDER,
                  'refund' => 'no'
                ));
                // Update next renewal date..
                $BOXHD->nextRenewalDate(array(
                  'package' => (array) $PACKAGE,
                  'order' => $ORDER->id,
                  'formatted' => 'no',
                  'return' => 'no',
                  'lang' => $gblang
                ));
                // Write event log..
                mswEventLog(array(
                  'member' => $ORDER->id,
                  'action' => $BOXHD->logMsg(array(
                    'slot' => ($ORDER->status != 'active' ? 7 : 5),
                    'status' => '',
                    'lang' => $adlang3,
                    'loglang' => $eventlog
                  )),
                  'prefs' => ($ORDER->eventlog ? unserialize($ORDER->eventlog) : array()),
                  'type' => 'payment',
                  'notes' => '',
                  'ip' => mswGetRealIPAddr()
                ), $DT, $DB, $SETTINGS);
                // Additional triggers..
                include(PATH . 'control/classes/payments/triggers/paypal.php');
              }
              $BOXHD->updatePosition($ORDER->id);
              // DEBUG..
              $BOXHD->debugHandler(array(
                'text' => 'Processing completed for status ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'yes'
              ));
            } else {
              $BOXHD->debugHandler(array(
                'text' => 'Termination: Currency/Cost (GW:' . $GATEWAY['currency'] . '/PK:' . $PACKAGE->currency . ' || GW:' . $BOXHD->currFormat($GATEWAY['amount']) . '/PK:' . $BOXHD->currFormat($PACKAGE->cost) . ') ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'no'
              ));
            }
            break;
          // Recurring payment failed..
          case 'RECURRING_INSTALLMENT_FAILED':
            if ($PACKAGE->type == 'subscr') {
              // Send to webmaster..
              if (in_array(7, $NOTIFY)) {
                $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-failed.txt'), $f_r);
                $sbj = $BOXHD->mailSubj(8);
                $mlMail->sendMail(array(
                  'to_name' => $SETTINGS->website,
                  'to_email' => $SETTINGS->email,
                  'from_name' => $GATEWAY['name'],
                  'from_email' => $ORDER->email,
                  'subject' => $sbj,
                  'msg' => $mlMail->htmlWrapper(array(
                    'global' => $gblang,
                    'title' => $sbj,
                    'header' => $sbj,
                    'content' => mswNL2BR($msg),
                    'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                  )),
                  'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                  'other' => $SETTINGS->smtp_other,
                  'plain' => $msg,
                  'htmlWrap' => 'yes'
                ), $gblang);
                $mlMail->smtpClose();
              }
              // Send to buyer..
              if (in_array(8, $NOTIFY)) {
                $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-failed-auto.txt'), $f_r);
                $sbj = $BOXHD->mailSubj(8);
                $mlMail->sendMail(array(
                  'to_name' => $GATEWAY['name'],
                  'to_email' => $ORDER->email,
                  'from_name' => $SETTINGS->website,
                  'from_email' => $SETTINGS->email,
                  'subject' => $sbj,
                  'msg' => $mlMail->htmlWrapper(array(
                    'global' => $gblang,
                    'title' => $sbj,
                    'header' => $sbj,
                    'content' => mswNL2BR($msg),
                    'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                  )),
                  'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                  'plain' => $msg,
                  'htmlWrap' => 'yes'
                ), $gblang);
                $mlMail->smtpClose();
              }
              // Disable account..
              $BOXHD->status(array(
                'id' => $ORDER->id,
                'status' => 'failed'
              ));
              // Write event log..
              mswEventLog(array(
                'member' => $ORDER->id,
                'action' => $BOXHD->logMsg(array(
                  'slot' => 6,
                  'status' => '',
                  'lang' => $adlang3,
                  'loglang' => $eventlog
                )),
                'prefs' => ($ORDER->eventlog ? unserialize($ORDER->eventlog) : array()),
                'type' => 'login',
                'notes' => '',
                'ip' => mswGetRealIPAddr()
              ), $DT, $DB, $SETTINGS);
              // DEBUG..
              $BOXHD->debugHandler(array(
                'text' => 'Processing completed for status ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'yes'
              ));
            }
            break;
          //Recurring payment stopped..
          case 'RECURRING_STOPPED':
            if ($PACKAGE->type == 'subscr') {
              // Send to webmaster..
              if (in_array(9, $NOTIFY)) {
                $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-stopped.txt'), $f_r);
                $sbj = $BOXHD->mailSubj(9);
                $mlMail->sendMail(array(
                  'to_name' => $SETTINGS->website,
                  'to_email' => $SETTINGS->email,
                  'from_name' => $GATEWAY['name'],
                  'from_email' => $ORDER->email,
                  'subject' => $sbj,
                  'msg' => $mlMail->htmlWrapper(array(
                    'global' => $gblang,
                    'title' => $sbj,
                    'header' => $sbj,
                    'content' => mswNL2BR($msg),
                    'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                  )),
                  'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                  'other' => $SETTINGS->smtp_other,
                  'plain' => $msg,
                  'htmlWrap' => 'yes'
                ), $gblang);
                $mlMail->smtpClose();
              }
              // Send to buyer..
              if (in_array(10, $NOTIFY)) {
                $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-stopped-auto.txt'), $f_r);
                $sbj = $BOXHD->mailSubj(9);
                $mlMail->sendMail(array(
                  'to_name' => $GATEWAY['name'],
                  'to_email' => $ORDER->email,
                  'from_name' => $SETTINGS->website,
                  'from_email' => $SETTINGS->email,
                  'subject' => $sbj,
                  'msg' => $mlMail->htmlWrapper(array(
                    'global' => $gblang,
                    'title' => $sbj,
                    'header' => $sbj,
                    'content' => mswNL2BR($msg),
                    'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                  )),
                  'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                  'plain' => $msg,
                  'htmlWrap' => 'yes'
                ), $gblang);
                $mlMail->smtpClose();
              }
              // Disable account..
              $BOXHD->status(array(
                'id' => $ORDER->id,
                'status' => 'stopped'
              ));
              // Remove entry from password file..
              if (HT_REM_SUB_REMOVAL) {
                $HTA->remove(array(
                  'user' => $ORDER->username,
                  'folder' => $BOX->lockbox,
                  'additional' => array(),
                  'skipmaster' => 'yes'
                ));
              }
              // Write event log..
              mswEventLog(array(
                'member' => $ORDER->id,
                'action' => $BOXHD->logMsg(array(
                  'slot' => 8,
                  'status' => '',
                  'lang' => $adlang3,
                  'loglang' => $eventlog
                )),
                'prefs' => ($ORDER->eventlog ? unserialize($ORDER->eventlog) : array()),
                'type' => 'login',
                'notes' => '',
                'ip' => mswGetRealIPAddr()
              ), $DT, $DB, $SETTINGS);
              // DEBUG..
              $BOXHD->debugHandler(array(
                'text' => 'Processing completed for status ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'yes'
              ));
            }
            break;
          // Recurring payment re-started..
          case 'RECURRING_RESTARTED':
            if (($GATEWAY['currency'] == $PACKAGE->currency) && ($BOXHD->currFormat($GATEWAY['amount']) >= $BOXHD->currFormat($PACKAGE->cost))) {
              if ($PACKAGE->type == 'subscr') {
                // Activation...
                switch ($PACKAGE->appold) {
                  case 'yes':
                    $BOXHD->status(array(
                      'id' => $ORDER->id,
                      'status' => 'rapprove'
                    ));
                    if ($HTA->checker(array(
                      'user' => $ORDER->username,
                      'folder' => $BOX->lockbox
                      )) == 'missing') {
                      $HTA->add(array(
                        'user' => $ORDER->username,
                        'pass' => '',
                        'box' => $BOX->lockbox,
                        'additional' => array(),
                        'shapass' => $ORDER->password
                      ));
                    }
                    $f_r['{STATUS}'] = $pblang3[18];
                    break;
                  case 'no':
                    $BOXHD->status(array(
                      'id' => $ORDER->id,
                      'status' => 'active'
                    ));
                    if ($HTA->checker(array(
                      'user' => $ORDER->username,
                      'folder' => $BOX->lockbox
                      )) == 'missing') {
                      $HTA->add(array(
                        'user' => $ORDER->username,
                        'pass' => '',
                        'box' => $BOX->lockbox,
                        'additional' => array(),
                        'shapass' => $ORDER->password
                      ));
                    }
                    $f_r['{STATUS}'] = $pblang3[19];
                    break;
                }
                // Send to webmaster..
                if (in_array(11, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-restarted.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(10);
                  $mlMail->sendMail(array(
                    'to_name' => $SETTINGS->website,
                    'to_email' => $SETTINGS->email,
                    'from_name' => $GATEWAY['name'],
                    'from_email' => $ORDER->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'other' => $SETTINGS->smtp_other,
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                // Send to buyer..
                if (in_array(12, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-restarted-auto.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(10);
                  $mlMail->sendMail(array(
                    'to_name' => $GATEWAY['name'],
                    'to_email' => $ORDER->email,
                    'from_name' => $SETTINGS->website,
                    'from_email' => $SETTINGS->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                // Add payment..
                $BOXHD->boxPayment(array(
                  'gateway' => $GATEWAY,
                  'order' => (array) $ORDER,
                  'refund' => 'no'
                ));
                // Update next renewal date..
                $BOXHD->nextRenewalDate(array(
                  'package' => (array) $PACKAGE,
                  'order' => $ORDER->id,
                  'formatted' => 'no',
                  'return' => 'no',
                  'lang' => $gblang
                ));
                // Write event log..
                mswEventLog(array(
                  'member' => $ORDER->id,
                  'action' => $BOXHD->logMsg(array(
                    'slot' => 9,
                    'status' => '',
                    'lang' => $adlang3,
                    'loglang' => $eventlog
                  )),
                  'prefs' => ($ORDER->eventlog ? unserialize($ORDER->eventlog) : array()),
                  'type' => 'payment',
                  'notes' => '',
                  'ip' => mswGetRealIPAddr()
                ), $DT, $DB, $SETTINGS);
                // DEBUG..
                $BOXHD->debugHandler(array(
                  'text' => 'Processing completed for status ' . $paymentStatus,
                  'gateway' => $BOXHD->gateway,
                  'finish' => 'yes'
                ));
              }
            } else {
              $BOXHD->debugHandler(array(
                'text' => 'Termination: Currency/Cost (GW:' . $GATEWAY['currency'] . '/PK:' . $PACKAGE->currency . ' || GW:' . $BOXHD->currFormat($GATEWAY['amount']) . '/PK:' . $BOXHD->currFormat($PACKAGE->cost) . ') ' . $paymentStatus,
                'gateway' => $BOXHD->gateway,
                'finish' => 'no'
              ));
            }
            break;
          // Pending..
          case 'PENDING':
            if ($GATEWAY['inv_status'] == 'approved') {
              $f_r['{REASON}'] = $BOXHD->pending(array(
                'paypend' => $paypend,
                'lang' => $gblang
              ));
              // Check currency and amount..
              if (($GATEWAY['currency'] == $PACKAGE->currency) && ($BOXHD->currFormat($GATEWAY['amount']) >= $BOXHD->currFormat($PACKAGE->cost))) {
                // Send to webmaster..
                if (in_array(1, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-pending.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(12);
                  $mlMail->sendMail(array(
                    'to_name' => $SETTINGS->website,
                    'to_email' => $SETTINGS->email,
                    'from_name' => $GATEWAY['name'],
                    'from_email' => $ORDER->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'other' => $SETTINGS->smtp_other,
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                // Send to buyer..
                if (in_array(2, $NOTIFY)) {
                  $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-pending-auto.txt'), $f_r);
                  $sbj = $BOXHD->mailSubj(13);
                  $mlMail->sendMail(array(
                    'to_name' => $GATEWAY['name'],
                    'to_email' => $ORDER->email,
                    'from_name' => $SETTINGS->website,
                    'from_email' => $SETTINGS->email,
                    'subject' => $sbj,
                    'msg' => $mlMail->htmlWrapper(array(
                      'global' => $gblang,
                      'title' => $sbj,
                      'header' => $sbj,
                      'content' => mswNL2BR($msg),
                      'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                    )),
                    'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                    'plain' => $msg,
                    'htmlWrap' => 'yes'
                  ), $gblang);
                  $mlMail->smtpClose();
                }
                $BOXHD->status(array(
                  'id' => $ORDER->id,
                  'status' => $ORDER->status
                ));
                // DEBUG..
                $BOXHD->debugHandler(array(
                  'text' => 'Processing completed for status ' . $paymentStatus,
                  'gateway' => $BOXHD->gateway,
                  'finish' => 'yes'
                ));
              }
            }
            break;
          // Refunded..
          case 'REFUNDED':
            $f_r['{REF_AMOUNT}'] = $GATEWAY['refund'];
            // Send to webmaster..
            if (in_array(13, $NOTIFY)) {
              $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-refund.txt'), $f_r);
              $sbj = $BOXHD->mailSubj(6);
              $mlMail->sendMail(array(
                'to_name' => $SETTINGS->website,
                'to_email' => $SETTINGS->email,
                'from_name' => $GATEWAY['name'],
                'from_email' => $ORDER->email,
                'subject' => $sbj,
                'msg' => $mlMail->htmlWrapper(array(
                  'global' => $gblang,
                  'title' => $sbj,
                  'header' => $sbj,
                  'content' => mswNL2BR($msg),
                  'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                )),
                'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                'other' => $SETTINGS->smtp_other,
                'plain' => $msg,
                'htmlWrap' => 'yes'
              ), $gblang);
              $mlMail->smtpClose();
            }
            // Send to buyer..
            if (in_array(14, $NOTIFY)) {
              $msg = strtr(file_get_contents(PATH . 'content/language/email-templates/order-refund-auto.txt'), $f_r);
              $sbj = $BOXHD->mailSubj(6);
              $mlMail->sendMail(array(
                'to_name' => $GATEWAY['name'],
                'to_email' => $ORDER->email,
                'from_name' => $SETTINGS->website,
                'from_email' => $SETTINGS->email,
                'subject' => $sbj,
                'msg' => $mlMail->htmlWrapper(array(
                  'global' => $gblang,
                  'title' => $sbj,
                  'header' => $sbj,
                  'content' => mswNL2BR($msg),
                  'footer' => (!defined('LICENCE_VER') || LICENCE_VER == 'locked' ? '' : $gblang[29])
                )),
                'reply-to' => ($SETTINGS->smtp_email ? $SETTINGS->smtp_email : $SETTINGS->email),
                'plain' => $msg,
                'htmlWrap' => 'yes'
              ), $gblang);
              $mlMail->smtpClose();
            }
            // Add payment..
            $BOXHD->boxPayment(array(
              'gateway' => $GATEWAY,
              'order' => (array) $ORDER,
              'refund' => 'yes'
            ));
            // Disable account..
            $BOXHD->status(array(
              'id' => $ORDER->id,
              'status' => 'refunded'
            ));
            // Remove entry from password file..
            if (HT_REM_SUB_REMOVAL) {
              $HTA->remove(array(
                'user' => $ORDER->username,
                'folder' => $BOX->lockbox,
                'additional' => array(),
                'skipmaster' => 'yes'
              ));
            }
            // Write event log..
            mswEventLog(array(
              'member' => $ORDER->id,
              'action' => $BOXHD->logMsg(array(
                'slot' => 10,
                'status' => '',
                'lang' => $adlang3,
                'loglang' => $eventlog
              )),
              'prefs' => ($ORDER->eventlog ? unserialize($ORDER->eventlog) : array()),
              'type' => 'payment',
              'notes' => '',
              'ip' => mswGetRealIPAddr()
            ), $DT, $DB, $SETTINGS);
            // DEBUG..
            $BOXHD->debugHandler(array(
              'text' => 'Processing completed for status ' . $paymentStatus,
              'gateway' => $BOXHD->gateway,
              'finish' => 'yes'
            ));
            break;
        }
        // DEBUG..
        $BOXHD->debugHandler(array(
          'text' => 'Debug completed for status ' . $paymentStatus,
          'gateway' => $BOXHD->gateway,
          'finish' => 'yes'
        ));
      } else {
        // DEBUG..
        $BOXHD->debugHandler(array(
          'text' => 'Order NOT found for id (' . $CUSTOM[1] . ') and code (' . $CUSTOM[0] . ')',
          'gateway' => $BOXHD->gateway,
          'finish' => 'yes'
        ));
      }
    }
  }
}

mswHeadCode($gblang[4], '200');

?>