<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  If you want to use a different template file, rename 'redirect.tpl.php' where applicable
  and create new template file.

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

header('Expires: Sun, 01 Jan 2014 00:00:00 GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');
header('Content-type: text/html; charset=utf-8');

define('PATH', dirname(__FILE__) . '/');
define('PARENT', 1);

// Load defined admin options..
include(PATH . 'control/defined.php');

// ERROR REPORTING..
include(PATH . 'control/classes/class.errors.php');
if (ERR_HANDLER_ENABLED) {
  register_shutdown_function('msFatalErr');
  set_error_handler('msErrorhandler');
}

// Initialise..
include(PATH . 'control/init.php');

$tmp = array();

switch ($p) {

  //------------------------------------
  // Account expired - subscriptions..
  //------------------------------------

  case 'expired':
    $tmp['title'] = $pblang5[2];
    $tmp['txt']   = $pblang5[4];
    $tmp['img']   = 'calendar-o';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Account expired - fixed access..
  //------------------------------------

  case 'fix-expired':
    $tmp['title'] = $pblang5[3];
    $tmp['txt']   = $pblang5[5];
    $tmp['img']   = 'clock-o';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Account requires approval or re-activation..
  //------------------------------------

  case 'approve':
    $tmp['title'] = $pblang5[1];
    $tmp['txt']   = $pblang5[6];
    $tmp['img']   = 'warning';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Lockbox is disabled..
  //------------------------------------

  case 'disabled':
    $tmp['title'] = $pblang5[0];
    $tmp['txt']   = $pblang5[7];
    $tmp['img']   = 'cube';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Account is disabled..
  //------------------------------------

  case 'acc-disabled':
    $tmp['title'] =  $pblang5[16];
    $tmp['txt']   =  $pblang5[17];
    $tmp['img']   = 'user-times';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Last payment failed..
  //------------------------------------

  case 'failed':
    $tmp['title'] = $pblang5[8];
    $tmp['txt']   = $pblang5[9];
    $tmp['img']   = 'warning';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Subscription was stopped..
  //------------------------------------

  case 'stopped':
    $tmp['title'] = $pblang5[10];
    $tmp['txt']   = $pblang5[11];
    $tmp['img']   = 'minus-circle';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Payment was refunded..
  //------------------------------------

  case 'refunded':
    $tmp['title'] = $pblang5[12];
    $tmp['txt']   = $pblang5[13];
    $tmp['img']   = 'money';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Awaiting subscription payment..
  //------------------------------------

  case 'payment':
    $tmp['title'] = $pblang5[14];
    $tmp['txt']   = $pblang5[15];
    $tmp['img']   = 'shopping-cart';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //----------------------------------------
  // IP block..
  //----------------------------------------

  case 'ip-block':
    $tmp['title'] = $pblang5[22];
    $tmp['txt']   = $pblang5[23];
    $tmp['img']   = 'flag';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Custom status..
  //------------------------------------

  case 'custom':
    $tmp['title'] = $pblang5[18];
    $tmp['txt']   = $pblang5[19];
    $tmp['img']   = 'exclamation-circle';
    $tmp['file']  = 'redirect.tpl.php';
    break;

  //------------------------------------
  // Default - 403
  //------------------------------------

  default:
    mswHeadCode($gblang[4], '403');
    break;

}

// Check redirect file exists..
if (file_exists(PATH . 'content/' . THEME . '/' . $tmp['file'])) {

  $browserTitle = mswSafeDisplay($tmp['title']);

  include(PATH . 'control/system/header.php');

  $tpl  = new Savant3();
  $tpl->assign('TMP', array(
    'template' => $tmp
  ));
  $tpl->display('content/' . THEME . '/' . $tmp['file']);

  // Global..
  include(PATH . 'control/lib/global.php');

  include(PATH . 'control/system/footer.php');

} else {

  die('Fatal Error: Redirect file "<b>content/' . THEME . '/' . $tmp['file'] . '</b>" doesn`t exist!');

}

?>